Attribute VB_Name = "mdlClouds"
Option Explicit

Public Sub AddRandomClouds()
 Static lngLastCloudTick As Long
 
 Randomize
 If (DirectX.TickCount - lngLastCloudTick) > 2000 + (Rnd * 600) Then
  AddClouds Int(((BackGroundX + 515) - BackGroundX + 1) * Rnd + BackGroundX), -195  'Start above screen
  lngLastCloudTick = DirectX.TickCount
 End If
End Sub


Public Sub AddClouds(X As Long, Y As Long)
 Dim I As Integer
 
 For I = 1 To TotalClouds
  If Clouds(I).Enabled = False Then GoTo AddNewClouds 'Skip creation of new cloud
 Next I
  
 TotalClouds = TotalClouds + 1
 I = TotalClouds
 ReDim Preserve Clouds(TotalClouds)
 
AddNewClouds:
 Randomize
 With Clouds(I)
  .X = X
  .Y = Y
  .Frame = 0 ' Int(Rnd * 2) - 1
  .Enabled = True
  .ShockTick = DirectX.TickCount + Int((3000 - 1000 + 1) * Rnd + 1000) 'Set Tick where lightning strikes
 End With

End Sub

Public Sub ShowClouds()
 Dim I As Integer, TempRect As RECT, Temprect2 As RECT, TempRect3 As RECT
 
 For I = 1 To TotalClouds
  
   With Clouds(I)
    If .Enabled = True Then
     'Just to be sure
     .Y = .Y + 3
     If .X < BackGroundX Or .X > (BackGroundX + 640) Then .Enabled = False
     If (.Y - 200) > GameOptions.ResY Then .Enabled = False 'a bit more than 195
     
     If (DirectX.TickCount - .ShockTick) > 0 Then 'Shocktime passed?
      .Frame = 2
      If (DirectX.TickCount - .ShockTick) > 700 + CInt(Rnd * 100) Then 'Stop Lightning
       .Frame = 0 'Int(Rnd * 2) - 1
       .ShockTick = DirectX.TickCount + Int((1500 - 800 + 1) * Rnd + 800) 'Set Tick where lightning strikes, again
      End If
     End If
     
     
     With TempRect
      .Top = 385
      .Bottom = 480
      .Left = 124 * Clouds(I).Frame
      .Right = .Left + 124
     End With
     With Temprect2
      .Top = Clouds(I).Y
      .Left = Clouds(I).X
      .Right = .Left + 124
      .Bottom = .Top + 72 'Why 72 instead of 195? well the shadow doesn't count...
     End With
     With TempRect3
      .Top = Player.Y
      .Left = Player.X
      .Bottom = .Top + 120
      .Right = .Left + 106
     End With
     
     
     If Tools.DetectCollision(Temprect2, TempRect3) = True Then
      If .Frame = 2 Then 'Cloud dangerous?
       If (DirectX.TickCount - Player.LastShock) > 3000 Then 'only shock when the last shock was more than 3 secs. ago.
       DSound.PlaySound dsZap
       AddHit
       End If
      End If
     End If
     
     If .Enabled = True Then
      Tools.DrawItem .X, .Y, TempRect, ddsSprites
     End If
    
    End If
  End With
 Next I
End Sub

