Attribute VB_Name = "mdlWeapons"
Option Explicit

Public Sub AddPlayerWeapon()
 'Purpose: Adding a player 'projectile'
 Dim I As Integer

    For I = 1 To TotalWeapons 'Check for obsolete weapons... Improves performance
        If Weapons(I).Enabled = False Then GoTo AddNewWeapon
    Next I
    
    TotalWeapons = TotalWeapons + 1
    I = TotalWeapons 'I has to be new weapon
    ReDim Preserve Weapons(I)
    
AddNewWeapon:
    With Weapons(I)
    .X = Player.X + 53 'Center of Player
    .Y = Player.Y - 2  'A bit before the player
    .Damage = 2
    .Enabled = True
    Dim lngCalcX As Long, lngCalcY As Long
    lngCalcX = 1 / GameOptions.ResX 'max is 1 for dsound.
    lngCalcY = 1 / GameOptions.ResY 'max is 1 for dsound.
    dsShoot3D.SetPosition lngCalcX * .X, 0, lngCalcY * .Y, DS3D_IMMEDIATE 'Set sound position
    DSound.PlaySound dsShoot         'Play sound (if enabled)
  
 End With
End Sub

Public Sub ShowWeapons()
 'Purpose: Blit weapons, after updating position
 Dim I As Integer, EmptyRect As RECT, I2 As Integer

    For I = 1 To TotalWeapons
        With Weapons(I)
            .Y = .Y - 2 'Weapons go up
            If .Y < 0 Then .Enabled = False 'if weapon is at top of screen
            If .Enabled = True Then
                DDSBack.BltFast .X, .Y, ddsWeapon, EmptyRect, DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
            End If
        End With
    Next I
End Sub
